Subject: Re: Bus Error on MPC8313

From: Scott Wood <[email-masked]>
Date: Fri, 13 Nov 2009 13:57:52 -0600

Ron Madrid wrote:
> --- On Fri, 11/13/09, Scott Wood <[email-masked]> wrote:
> 
>> From: Scott Wood <[email-masked]>
>> Subject: Re: Bus Error on MPC8313
>> To: "Ron Madrid" <[email-masked]>
>> Cc: [email-masked]
>> Date: Friday, November 13, 2009, 11:33 AM
>> Ron Madrid wrote:
>>> I wrote a custom driver for an MPC8313 based
>> board.  Everything seems to
>>> have been working for a long time, but now one of my
>> IOCTL functions seems
>>> to be having a problem.  I'm getting a "Bus
>> error" reported by my
>>> application and also a kernel "Oops".  Here's
>> what the kernel is reporting. 
>>> Oops: Machine check, sig: 7 [#1]
>> Were there any messages before this?  Is there
>> anything interesting in the arbiter registers?
> 
> No messages prior, only the normal kernel boot messages. 

Hmm, for some reason e300c3's cputable entry has no machine_check field, 
while all the other e300s point to machine_check_generic.

> And when this
> does happen in usually causes a lockup, so I haven't been able to check the
> status of any arbiter registers.

The system is up long enough to print an oops; you could stick some 
output in the trap handler.

>> Is this custom driver using the localbus, and are there any
>> NAND operations going on at the same time?
> 
> This driver does use the localbus. 

OK, check the localbus error registers as well.

> It seems to happen (when it does) when
> performing an access to our FPGA that is connected via UPM on the localbus. 
> I do not know if there are any NAND operations going on at that same time. 
> If there are, they are not being directly caused by any of my apps or
> driver calls.

Are there any filesystems mounted on NAND?  There are some issues with 
transactions timing out if there's contention with a long-running NAND 
operation.

-Scott